package com.ruoyi.web.base.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.ProcureApportion;
import com.ruoyi.web.base.service.IProcureApportionService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

/**
 * <p>
 * 分摊 前端控制器
 * </p>
 *
 * @author author
 * @since 2026-02-05
 */
@RestController
@RequestMapping("/procure-apportion")
public class ProcureApportionController {
    @Autowired
    private IProcureApportionService procureApportionService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("分摊管理添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody ProcureApportion procureApportion, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (procureApportionService.count(new QueryWrapper<ProcureApportion>().eq("org_id",loginOrgId).eq("goods_num", procureApportion.getGoodsNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        procureApportion.setOrgId(loginOrgId);
        procureApportion.setCreateBy(getUsername());

        return success(procureApportionService.save(procureApportion));
    }

    @ApiOperation("分摊管理修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody ProcureApportion procureApportion, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        if (procureApportionService.count(new QueryWrapper<ProcureApportion>().ne("id",procureApportion.getId()).eq("org_id",loginOrgId).eq("goods_num", procureApportion.getGoodsNum())) >0 ){
            throw new Exception("该编号已存在");
        }
        procureApportion.setUpdateBy(getUsername());
        return success(procureApportionService.updateById(procureApportion));
    }

    @ApiOperation("分摊管理删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String s : ids.split(",")) {
            procureApportionService.removeById(s);
        }
        return success();
    }

    @ApiOperation("分摊管理列表")
    @PostMapping("/list")
    public AjaxResult listAll( HttpServletRequest request){

        return success(procureApportionService.list(new QueryWrapper<ProcureApportion>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("分摊管理分页")
    @GetMapping("/page")
    public AjaxResult page(@RequestParam("pageNum") Integer pageNum, @RequestParam("pageSize") Integer pageSize
            , HttpServletRequest request) {
        return success(procureApportionService.page(new Page<ProcureApportion>(pageNum,pageSize),new QueryWrapper<ProcureApportion>().eq("org_id", tokenService.getLoginOrgId(request))));
    }

    @ApiOperation("分摊管理详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap){
        String id = paramsMap.get("id");
        return success(procureApportionService.getById(id));
    }

}
